设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 228|回复: 4

[研讨] 在固定区域内生成均匀随机点

[复制链接]

已领礼包: 1724个

财富等级: 堆金积玉

发表于 2020-2-12 01:54:44 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
本帖最后由 aimisiyou 于 2020-2-12 08:22 编辑

如图,区域内随机生成的点均匀性不是很好,这跟随机函数有很大关系。
(defun fun_point (p1 p2 p3)
  (defun rnd ()
     (*(rem (getvar "cputicks") 1e4) 1e-4)
  )
(command "pline" p1 p2 p3 "c")
  (setq ptlst nil)
  (repeat 200
      (setq r1 (rnd) r2 (rnd))
          (setq ptlst (cons (list
                                (+ (* (- 1 r2) (- 1 r1) (car p1)) (* (- 1 r2) r1 (car p2)) (* r2 (car p3)))
                                    (+ (* (- 1 r2) (- 1 r1) (cadr p1)) (* (- 1 r2) r1 (cadr p2)) (* r2 (cadr p3)))   
                             )      
                                          ptlst
                       )
         )
   )
(mapcar '(lambda (x)
             (entmake
                             (list
                                  '(0 . "point")                        
                                  '(100 . "AcDbEntity")
                                  '(100 . "AcDbPoint")                                 
                                  '(67 . 0)                                 
                                  (cons 10 (list (car x) (cadr x)))            
                                  (cons 210 '(0 0 1))                                                         
                               )                     
                      )
                         )
                        ptlst
)
)
(fun_point '(0 0) '(100 100) '(200 0))


-2faf33e824926581.png
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 1724个

财富等级: 堆金积玉

 楼主| 发表于 2020-2-12 10:10:43 | 显示全部楼层
本帖最后由 aimisiyou 于 2020-2-12 10:21 编辑

既然改变不了随机函数的特性,那么我们就依次调整下三个点的排列位置,尽量得到"较均匀分布"的点。
(defun fun_point (p1 p2 p3)
  (defun rnd ()
     (*(rem (getvar "cputicks") 1e4) 1e-4)
  )
(command "pline" p1 p2 p3 "c")
  (setq ptlst nil)
  (repeat 100
      (setq r1 (abs (cos (* pi (/ (atan (log (rnd))) (/ pi 2.0))))))
      (setq r2 (abs (cos (* pi (/ (atan (log (rnd))) (/ pi 2.0))))))
          (setq ptlst (cons (list
                                (+ (* (- 1 r2) (- 1 r1) (car p1)) (* (- 1 r2) r1 (car p2)) (* r2 (car p3)))
                                    (+ (* (- 1 r2) (- 1 r1) (cadr p1)) (* (- 1 r2) r1 (cadr p2)) (* r2 (cadr p3)))   
                             )  
                                          ptlst
                       )
         )
      (setq r1 (abs (cos (* pi (/ (atan (log (rnd))) (/ pi 2.0))))))
      (setq r2 (abs (cos (* pi (/ (atan (log (rnd))) (/ pi 2.0))))))
          (setq ptlst (cons (list
                                (+ (* (- 1 r2) (- 1 r1) (car p2)) (* (- 1 r2) r1 (car p3)) (* r2 (car p1)))
                                    (+ (* (- 1 r2) (- 1 r1) (cadr p2)) (* (- 1 r2) r1 (cadr p3)) (* r2 (cadr p1)))   
                             )  
                                          ptlst
                       )
         )
      (setq r1 (abs (cos (* pi (/ (atan (log (rnd))) (/ pi 2.0))))))
      (setq r2 (abs (cos (* pi (/ (atan (log (rnd))) (/ pi 2.0))))))
          (setq ptlst (cons (list
                                (+ (* (- 1 r2) (- 1 r1) (car p3)) (* (- 1 r2) r1 (car p1)) (* r2 (car p2)))
                                    (+ (* (- 1 r2) (- 1 r1) (cadr p3)) (* (- 1 r2) r1 (cadr p1)) (* r2 (cadr p2)))   
                             )  
                                          ptlst
                       )
         )
   )
(mapcar '(lambda (x)
             (entmake
                             (list
                                  '(0 . "point")                        
                                  '(100 . "AcDbEntity")
                                  '(100 . "AcDbPoint")                                 
                                  '(67 . 0)                                 
                                  (cons 10 (list (car x) (cadr x)))            
                                  (cons 210 '(0 0 1))                                                         
                               )                     
                      )
                         )
                        ptlst
)
)
(fun_point '(0 0) '(100 100) '(200 0))

265fac39f9977152.png
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 1 反对 0

使用道具 举报

已领礼包: 1724个

财富等级: 堆金积玉

 楼主| 发表于 2020-2-12 10:05:52 | 显示全部楼层
为了拉开两个连续随机数的距离,可采用log函数。经改进后,效果图有些进步,但仍不理想,靠近P3处密集,P2处稀疏,P1处介于两者之间。
-7ba77c8d2e813f1f.png
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 3029个

财富等级: 富可敌国

发表于 2020-2-14 00:04:52 | 显示全部楼层
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

已领礼包: 1724个

财富等级: 堆金积玉

 楼主| 发表于 2020-2-16 10:41:53 | 显示全部楼层
可应用到平面找点的问题。随机生成点后,可获得各点对应的函数值,整体有一个最优值,定义局部半径r,局部内的点向局部最优值移动,局部最优值向整体最优值移动,整体最优值随机小范围扰动。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2020-9-28 03:13 , Processed in 0.137647 second(s), 44 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表